/**
 * The MIT License (MIT)
 * Copyright (c) 2017-present Dmitry Soshnikov <dmitry.soshnikov@gmail.com>
 */

'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BuiltInGate = require('../BuiltInGate');

/**
 * Canonical truth table for the `Not` gate.
 */
var TRUTH_TABLE = [{ in: 0, out: 1 }, { in: 1, out: 0 }];

/**
 * A bitwise 1-bit Not gate.
 */

var Not = function (_BuiltInGate) {
  _inherits(Not, _BuiltInGate);

  function Not() {
    _classCallCheck(this, Not);

    return _possibleConstructorReturn(this, (Not.__proto__ || Object.getPrototypeOf(Not)).apply(this, arguments));
  }

  _createClass(Not, [{
    key: 'eval',

    /**
     * ~in
     */
    value: function _eval() {
      var a = this.getInputPins()[0].getValue();
      this.getOutputPins()[0].setValue(1 - a);
    }
  }]);

  return Not;
}(BuiltInGate);

/**
 * Specification of the `Not` gate.
 */


Not.Spec = {
  name: 'Not',
  description: 'Implements bitwise 1-bit Not ~ operation.',
  inputPins: ['in'],
  outputPins: ['out'],
  truthTable: TRUTH_TABLE
};

module.exports = Not;