/**
 * The MIT License (MIT)
 * Copyright (c) 2017-present Dmitry Soshnikov <dmitry.soshnikov@gmail.com>
 */

'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BuiltInGate = require('../BuiltInGate');

/**
 * Canonical truth table for the `Xor` gate.
 */
var TRUTH_TABLE = [{ a: 0, b: 0, out: 0 }, { a: 0, b: 1, out: 1 }, { a: 1, b: 0, out: 1 }, { a: 1, b: 1, out: 0 }];

/**
 * A bitwise 1-bit Xor gate.
 */

var Xor = function (_BuiltInGate) {
  _inherits(Xor, _BuiltInGate);

  function Xor() {
    _classCallCheck(this, Xor);

    return _possibleConstructorReturn(this, (Xor.__proto__ || Object.getPrototypeOf(Xor)).apply(this, arguments));
  }

  _createClass(Xor, [{
    key: 'eval',

    /**
     * a ^ b
     */
    value: function _eval() {
      var a = this.getInputPins()[0].getValue();
      var b = this.getInputPins()[1].getValue();

      this.getOutputPins()[0].setValue(a ^ b);
    }
  }]);

  return Xor;
}(BuiltInGate);

/**
 * Specification of the `Xor` gate.
 */


Xor.Spec = {
  name: 'Xor',
  description: 'Implements bitwise 1-bit Xor ^ operation.',
  inputPins: ['a', 'b'],
  outputPins: ['out'],
  truthTable: TRUTH_TABLE
};

module.exports = Xor;