/**
 * The MIT License (MIT)
 * Copyright (c) 2017-present Dmitry Soshnikov <dmitry.soshnikov@gmail.com>
 */

'use strict';

function centerString(string, maxLength) {
  var padCh = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : ' ';

  if (string.length < maxLength) {
    var len = maxLength - string.length;
    var remain = len % 2 == 0 ? '' : padCh;
    var pads = padCh.repeat(parseInt(len / 2));
    return pads + string + pads + remain;
  }
  return string;
}

module.exports = {
  centerString: centerString
};